// Header File
// Created 6/23/2006; 8:57:40 PM
/*Copyright (C) <year>  <name of author>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/



// newline function
void newline(void){
	printf("\n");
	loop = 0;
}
//

void pagebreak(void){
	printf("\n\n\n\n\n\n\n\n");
}

// newpage function
void newpage(void){
		clrscr();
		x = 0;
    y = 0;
    loop = -1;
    pageloop = -1;
    printf("new page -- chars cleared\n\n\npress any key...");
    ngetchx();
    clrscr();
    pagebreak();
}
//


//--this saves/restores screen after displaying help, but does not adjust the cursor position.
void help(void){
	//loop--;  i have no idea why i had this line here...
	LCD_save(lcdbuffer);
	ClrScr();
	printf_xy(0,0,"The Help Screen");
	printf_xy(0,10,"sys commands = ");
	printf_xy(0,20,"hlp -- disp help");
	printf_xy(0,30,"cls -- clear screen");
	printf_xy(0,40,"end -- terminate program");
	printf_xy(0,50,"off -- turn off calulator");
	printf_xy(0,60,"pts -- print the buffer");
	printf_xy(0,70,"press a key...");
	ngetchx();
	ClrScr();
	printf_xy(0,0,"to type hiragana, type the");
	printf_xy(0,10," reading in lowercase");
	printf_xy(0,20,"to type katakana, type the");
	printf_xy(0,30," reading in uppercase");
	printf_xy(0,40,"kanji are not supported yet");
	printf_xy(0,55,"beta - cst,prs,prp");
	printf_xy(0,70,"press a key...");
	ngetchx();
	
	LCD_restore(lcdbuffer);
}

// opening screen
void startscreen(void){
	clrscr();
	//startscreentest++;
		printf("ime16 version ");printf("%d.%d.%d.%d",COMMENT_VERSION_NUMBER);printf("\nby nebousuru\n");
		printf("sys commands = \nhlp -- disp help\ncls -- clear screen\nend -- terminate program\noff -- turn off calulator\npts -- print buffer");
    printf("\nThis program is partially GPL'ed. See Readme.\npress any key...");
	ngetchx();
	clrscr();
}
//


/*
//this is meant to cycle through all user input and figure out which characters and commands were inputed.
It works by 
		i)finding if a vowel is the first character.  if it is, stop this ititeration --- this is for a-line kana
 	 ii)finding if a consonant is the and a vowel is second.  if it is, stop --- for most other kana
 	iii)find ing if all three are consonat --- command string
*/




/*start parse function
it needs to be "upside down" to work -- last funtion called comes first, first func called comes last.
this way it is sane

*/
void endparse2(void){
	printf(parsehold);
	
		}		

void vowelsecond(void){
		offset++;
		printf("consonant,vowel");
		endparse2();
		}


void vowelfirst(void){
		offset++;
		printf("vowel");
		endparse2();
		}

void vowelthird(void){
		offset++;
		printf("conconvow");
		endparse2();
		}

void consonantthird(void){
		offset++;
		printf("command");
		endparse2();
		}

void consonantsecond(void){
		offset++;
		parse_buffer[2] = store[offset];
		parsehold[2] = parse_buffer[2];
		for(i=0;i<consonantlength;i++){
		if(strcmp(&parse_buffer[2],&consonant[i]) == 0){
			consonantthird();
		}
		}
		for(i=0;i<vowellength;i++){
		if(strcmp(&parse_buffer[2],&vowel[i]) == 0){
			vowelthird();
		}}}


void consonantfirst(void){
		offset++;
		parse_buffer[1] = store[offset];
		parsehold[1] = parse_buffer[1];
		for(i=0;i<consonantlength;i++){
		if(strcmp(&parse_buffer[1],&consonant[i]) == 0){
			consonantsecond();
		}
		}
		for(i=0;i<vowellength;i++){
		if(strcmp(&parse_buffer[1],&vowel[i]) == 0){
			vowelsecond();
		}}
		}



	

//char parse_buffer[4] = "";
void parse(void){	
	
	/*for(i=0;i==3;i++){//this doesn't work right
	parsehold[i] = *"\0";
	}*/
	
	parsehold[0] = *"\0";//this makes it so when teststr is printed it only goes to the last char
  parsehold[1] = *"\0";
	parsehold[2] = *"\0";
	parsehold[3] = *"\0";
	
	parse_buffer[0] = *"\0";//this makes it so when teststr is printed it only goes to the last char
  parse_buffer[1] = *"\0";
	parse_buffer[2] = *"\0";
	parse_buffer[3] = *"\0";
	
	/**strcpy(parsehold,"");
	*strcpy(parse_buffer,"");*/
	
	
	parse_buffer[0] = store[offset];
		parsehold[0] = parse_buffer[0];

		for(i=0;i<vowellength;i++){
		if(strcmp(&parse_buffer[0],&vowel[i]) == 0){
			vowelfirst();
		}}
		for(i=0;i<consonantlength;i++){
		if(strcmp(&parse_buffer[0],&consonant[i]) == 0){
			consonantfirst();
		}
			
		
}}
// end of parse function
		
		
		
		
void clearstore(void){
  *strcpy(store,"");
//these need to be reset here for some reason(i think, no proof)
  parsehold[0] = *"\0";
  parsehold[1] = *"\0";
	parsehold[2] = *"\0";
	parsehold[3] = *"\0";
	
	parse_buffer[0] = *"\0";//this makes it so when teststr is printed it only goes to the last char
  parse_buffer[1] = *"\0";
	parse_buffer[2] = *"\0";
	parse_buffer[3] = *"\0";
	
	offset = 0;//this needs to be reset so when pointer store is 'cleared' offset doesn't force old data to be put into parse_buffer
}
		
		
		

		
void parseprint(void){
//char parseprint[4] = "";
	parse();
	drawsprite(parsehold);
}



